
#include "netscan.h"

int npuertos = 0;

int *rand_puertos;

struct host *lista_hosts = NULL;

struct puerto *puertos = NULL;

int start_time, end_time;

int scan_timeout_sec = 2, scan_timeout_msec = 0;

int acks = 0, noresuelve = 0, src, e, tcnt = 0, tacks = 0, tfil = 0;

int filtrados = 0;

int sd;

int MAX_PACKETS = 100;

int head_offset;

char *itz = NULL;

int ack_port = 80, nhosts = 0, solohosts = 0;

int debug = 0, verbose = 0;

int iniciado = 0;

struct in_addr ip_src;

struct host *host_scanned = NULL;

struct timeval timenow;

int timeout_sec, timeout_usec;

void read_etc_services();
void scan_ports();
void print_results();
void new_puerto(int n);
void randomize();
void enlaza(int, char*);
int procesa_packet();
int add_unreach_port(struct in_addr, unsigned short);
void new_socket();

extern int read_ip_packet(char* , int);
extern char *get_ifaz();
extern struct in_addr TCP_wait_open(unsigned short *sp, unsigned short *dp, int timeout, unsigned short ddp);  
extern struct in_addr ICMP_wait_unreach(unsigned short *dp, int timeout);
extern struct in_addr mi_ip();
extern void ping_hosts();
extern void ack_hosts();
extern void tstamp_hosts();
extern void parse_target(char *target);
extern char *next_target(int, char**, char*);
extern void init_rng();
extern void TCP(int fd, struct in_addr sdir, struct in_addr ddir, 
	 unsigned short sp, unsigned short dp, unsigned char flags);
extern int misocket(int, int, int);
extern void osdetect(struct in_addr, int, int);


int solo_pings = 0;

int nscans = 0;
int ntipos = 0;

int osdetectf = 0;

FILE *logfile = NULL;

int ports_to_scan[0xffff];

void uso(char *arg)
{
  printf("Uso: %s [Tipo de scan] [opciones] <host>[/mascara]\n", arg);
  printf("Tipos de scan:\n");
  printf(" -sS\t\tAnalogo al stealth tcp SYN scan del nmap (por defecto)\n");
  printf(" -sP\t\tNo busca puertos abiertos, solo hosts activos (ping scan)\n");
  printf("Opciones:\n");
  printf(" -PI\t\tUsa solo icmp pings para averiguar si un host esta activo\n");
  printf(" -PT[puerto]\tUsa solo tcp acks para averiguar si un host esta activo\n");
  printf("\t\tEl puerto por defecto es el 80\n");
  printf(" -PC\t\tUsa solo icmp timestamps para averiguar si un host esta activo\n");
  printf("\t\tCon este scan se muestran los diferentes hosts de una subred\n");
  printf("\t\tcalculando la sincronizacion entre ellos\n");
  printf(" -p <puerto>\tEscanea <puerto> (Puedes poner rangos ej. 1-100)\n");
  printf(" -O\t\tMuestra la huella dactilar de la pila TCP/IP del host escaneado\n");
  printf(" -S <ip>\tUsa <ip> como ip fuente en los escaneos\n");
  printf(" -o <file>\tGuarda un log del scan en <file>\n");
  printf(" -T <msec>\tPone el timeout en milesimas de segundo para el ping scan\n");
  printf(" -M <n>\tUsa <n> como el # maximo de paquetes enviados\n");
  printf(" -n\t\tNo resuelve el nombre de los hosts\n");
  printf(" -i <interfaz>\tUsa <interfaz> para escuchar paquetes. Esta opcion solo es\n");
  printf("\t\tnecesaria si netscan no puede adivinar la interfaz correcta\n");
  printf(" -v[v]\t\tMuestra info adicional\n");
  printf(" -h\t\tMuestra esto que estas leyendo\n");
  printf(" -V\t\tMuestra la version y sale\n");
  printf("Por defecto se escanean los puertos en /etc/services y se envian icmp pings y tcp acks para saber si un host esta activo\n");
  exit(0);
}

void set_ports(char *rango)
{
  int start, end;
  char tmp[32];
  int c;
  if (!strstr(rango,"-")) {
    puertos = (struct puerto*) malloc(sizeof(struct puerto)); 
    c = atoi(rango);
    if ((!c) || (c > 0xffff)) {
      printf(" Error: puerto no valido\n");
      exit(0);
    }
    new_puerto(c);
    return;
  }
  if (rango[0] == '-') {
    printf(" Error: rango de puertos no valido\n");
    exit(0);
  }
  memset(tmp, 0, 32);
  for (c = 0; c < 32; c++) {
    if (rango[c] == '-') break;
    tmp[c] = rango[c];
  }
  start = atoi(tmp);
  if (strlen(rango) == (c - 1)) end = 0xffff;
  else end = atoi(&rango[c+1]);
  if ((start < 1) || (end > 0xffff) || (start >= end)) {
    printf(" Error: rango de puertos no valido\n");
    exit(0);
  } 
  puertos = (struct puerto*) malloc((end - start) * sizeof(struct puerto));
  for (;start <= end; start++) new_puerto(start);
}

/* Chequea si existe el fichero name */
int exists(char *name)
{
  int fd = open(name, O_RDONLY);
  if (fd < 0) return 0;
  close(fd);
  return 1;
}

void fin(int n)
{
  exit(0);
}

void control_c(int n)
{
  printf("Interrumpido a peticion del usuario\n");
  exit(0);
}

int main(int argc,char *argv[])
{
  char opt;
  int c, nargc, scantype = 0, scan_etc = 1;
  char *opts = "s:p:S:o:T:dhnVi:vP:OM:";
  char *ptr;
  char **nargv;
  char *tmpbuf = NULL;

  printf("NetScan v1.5BETA - By Doing <jdoing@bigfoot.com>\n");

  memset(ports_to_scan, 0, sizeof(ports_to_scan));

  if (argc < 2) uso(argv[0]);

/* Ponemos una semilla aleatoria */ 
  init_rng();

/* Creamos una copia de los argumentos, porque getopt() los trastoca */
  nargc = argc;
  nargv = (char**) malloc(4 * argc);
  for (c = 0; c < argc; c++) {
    nargv[c] = (char*) malloc(strlen(argv[c]) + 1);
    strncpy(nargv[c], argv[c], strlen(argv[c]) + 1);
  }

/* Procesamos los argumentos */
  while ((opt = getopt(argc, argv, opts)) != EOF) 
    switch(opt) {
    case 's':
      if (optarg[0] == 'P') {
	solohosts = 1;
	nscans++;
	break;
      }
      if (optarg[0] == 'S') {
	solohosts = 0;
	nscans++;
	break;
      }
      printf("Error: Tipo de scan desconocido\n");
      uso(argv[0]);
    case 'P':
      if (optarg[0] == 'I') {
	solo_pings = 1;
	ntipos++;
	break;
      }
      if (optarg[0] == 'C') {
	scantype = 2;
	ntipos++;
	break;
      }
      if (optarg[0] == 'T') {
	scantype = 1;
	ntipos++;
	if (optarg[1] == 0) break;
	tmpbuf = (char*) malloc(strlen(optarg));
	strcpy(tmpbuf, &optarg[1]);  
	ack_port = atoi(tmpbuf);
	if ((ack_port < 1) || (ack_port > 0xffff)) {
	  printf("Error: Puerto no valido\n");
	  exit(0);
	}
	free(tmpbuf);
	break;
      }
      printf("Error: Opcion desconocida\n");
      uso(argv[0]);
    case 'i':
      itz = (char*) malloc(strlen(optarg) + 1);
      strncpy(itz, optarg, strlen(optarg) + 1);
      break;
    case 'p':
      if (puertos) {
	printf("Error: La opcion -p solo puede usarse una vez\n");
	exit(0);
      }
      scan_etc = 0;
      set_ports(optarg);
      randomize();
      break;
    case 'S':
      ip_src.s_addr = inet_addr(optarg); break;
    case 'o':
      if (exists(optarg)) {
	printf(" Error: %s existe\n", optarg);
	exit(0);
      }
      logfile = fopen(optarg,"w");
      if (!logfile) {
	printf(" Error creando %s: %s\n", optarg, strerror(errno));
	exit(0);
      }
      break;
    case 'T':
      scan_timeout_msec = atoi(optarg);     
      scan_timeout_sec = (scan_timeout_msec / 1000) - 1;
      scan_timeout_msec = scan_timeout_msec - ((scan_timeout_sec+1) * 1000);
      scan_timeout_msec *= 1000;
      break;
    case 'n':
      noresuelve = 1;
      break;
    case 'd':
      debug++;
      break;
    case 'v':
      verbose++;
      break;
    case 'V':
      exit(0);
    case 'h':
      uso(argv[0]);
    case 'O':
      osdetectf = 1;
      break;
    case 'M':
      MAX_PACKETS = atoi(optarg);
      break;
    default:
      uso(argv[0]);
    }

  if (nscans > 1) {
    printf("Error: Solo puedes especificar un tipo de scan a la vez\n");
    exit(0);
  }

  if (ntipos > 1) {
    printf("Error: Solo puedes usar una de estas opciones a la vez: -PI, -PT y -PC\n");
    exit(0);
  }


/* Miramos si el usuario ha especificado algun objetivo */
  while ((ptr = next_target(nargc, nargv, opts))) {
    parse_target(ptr);
    if (logfile) {
      fprintf(logfile, "Escaneando %s\n", ptr);
      fflush(logfile);
    }
  }

  signal(SIGINT, control_c);
  signal(SIGSTOP, control_c);

  start_time = time(NULL);

/* Si no se especifican puertos se leen los de /etc/services */
  if (scan_etc) {
    read_etc_services();
    randomize();
  }
  
  if (!itz) itz = get_ifaz();
  new_socket();

  if (scantype == 0) ping_hosts();
  if (scantype == 1) ack_hosts();
  if (scantype == 2) tstamp_hosts();

/*
  Si no hay ningun host activo o el usuario no especifico ninguno en
  la linea de comandos salimos
*/  
  if (!nhosts) {
    end_time = time(NULL);
    printf("\n0 hosts escaneados en %i sec.\n", end_time - start_time);
    if (logfile) {
      fprintf(logfile, "\n0 hosts escaneados en %i sec.\n", end_time - start_time);
      fclose(logfile);
    }
    fin(0);
  }

  if (!solohosts) {
    scan_ports();
    
    end_time = time(NULL);
    printf("\n%i host%s escaneado%s en %i sec.\n", nhosts, (nhosts > 1) ? "s" : "", (nhosts > 1) ? "s" : "", end_time - start_time);
    if (logfile)
      fprintf(logfile, "\n%i host%s escaneado%s en %i sec.\n", nhosts, (nhosts > 1) ? "s" : "", (nhosts > 1) ? "s" : "", end_time - start_time);
    if (logfile) fflush(logfile);
  
  } else {
    end_time = time(NULL);
    printf("\n%i host%s escaneado%s en %i segundos\n", nhosts, (nhosts > 1) ? "s" : "", (nhosts > 1) ? "s" : "", end_time - start_time);
    if (logfile) 
      fprintf(logfile, "\n%i host%s escaneado%s en %i segundos\n", nhosts, (nhosts > 1) ? "s" : "", (nhosts > 1) ? "s" : "", end_time - start_time);
  }
  if (logfile) fclose(logfile);
  return 0;
}

void new_socket()
{
  int c;
  
  if (iniciado) close(sd);

  sd = misocket(AF_INET, SOCK_PACKET, htons(ETH_P_IP));

  fcntl(sd, F_SETFL, O_NONBLOCK);
  
  enlaza(sd, itz);

  c = 0xfffff;
  if (setsockopt(sd, SOL_SOCKET, SO_RCVBUF, &c, 4)) 
    perror("setsockopt()");

  if (setsockopt(sd, SOL_SOCKET, SO_SNDBUF, &c, 4)) 
    perror("setsockopt()");
}


struct puerto *ordena(int n, struct puerto *pt)
{
  struct puerto *ret;
  int c = 0, d, cur = 0;

  ret = (struct puerto*) malloc(sizeof(struct puerto) * n);

  for (c = 0; c < 0xffff; c++) 
    for (d = 0; d < n; d++) 
      if (pt[d].n == c) {
	ret[cur++].n = c;
	ret[cur-1].st = pt[d].st;
	break;
      }
  
  return ret;
}

int es_puerto_a_escanear(int p)
{
  int c;
  for (c = 0; c < npuertos; c++) if (rand_puertos[c] == p) return 1;
  return 0;
}

void print_results(struct host *ht)
{
  struct puerto *pt, *pts;
  int n, c;
  struct servent *se;
  struct host *mak;
  int oport = 0, cport = 60000 + (rand() % 5000);

  for (c = 0; c < 0xffff; c++) if (!ht->respuestas[c] && ports_to_scan[c]) add_unreach_port(ht->dir, c);
  
  mak = ht->next_mak;
  if (ht->npuertos) {
    printf("\nPuertos en %s (%s):\n", ht->name, inet_ntoa(ht->dir));
    while (mak) {
      printf("\t|----> %s (%s)\n", mak->name, inet_ntoa(mak->dir));
      mak = mak->next_mak;
    }
    printf("Puerto\t\tEstado\t\tServicio\n");
    if (logfile) {
      fprintf(logfile, "\nPuertos en %s (%s):\n", ht->name, inet_ntoa(ht->dir));
      mak = ht->next_mak;
      while (mak) {
	fprintf(logfile, "\t|----> %s (%s)\n", mak->name, inet_ntoa(mak->dir));
	mak = mak->next_mak;
      }
      fprintf(logfile, "Puerto\t\tEstado\t\tServicio\n");
    }
    pt = ht->puertos;
    pts = ordena(ht->npuertos, pt);
    n = ht->npuertos;
    for (c = 0; c < n; c++) {
      se = getservbyport(htons(pts[c].n), "tcp");
      printf(" %i\t\t%s\t %s\n",pts[c].n, (pts[c].st) ? "filtrado" : "abierto\t", se ? se->s_name : "desconocido");
      if (logfile) fprintf(logfile, " %i\t\t%s\t %s\n",pts[c].n, (pts[c].st) ? "filtrado" : "abierto\t", se ? se->s_name : "desconocido");
      if (!oport) if (!pts[c].st) oport = pts[c].n;
    }
    free(pts);
  } else {
    printf("\n%s (%s) no tiene puertos abiertos\n", ht->name, inet_ntoa(ht->dir));
    while (mak) {
      printf("\t|----> %s (%s)\n", mak->name, inet_ntoa(mak->dir));
      mak = mak->next_mak;
    }

    if (logfile) {
      mak = ht->next_mak;
      fprintf(logfile, "\n %s (%s) no tiene puertos abiertos\n", ht->name, inet_ntoa(ht->dir));
      while (mak) {
	fprintf(logfile, "\t|----> %s (%s)\n", mak->name, inet_ntoa(mak->dir));
	mak = mak->next_mak;
      }
    }
  }
  if (osdetectf) {
    if (!oport) {
      printf("%s (%s) no tienen puertos abiertos, no puedo crear su huella dactilar\n", ht->name, inet_ntoa(ht->dir));
      return;
    }
    osdetect(ht->dir, oport, cport);
  }
}

void randomize()
{
  struct puerto *ptr = puertos;
  int c, pos = 0;

  rand_puertos = (int*) malloc(npuertos * sizeof(int));
  memset(rand_puertos, 0, npuertos * sizeof(int));
  
  for (c = 0; c < npuertos; c++) {
    while (rand_puertos[pos]) pos = rand() % npuertos;
    rand_puertos[pos] = ptr[c].n;  
  }
}

/*
  Mira si la direccion dada pertenece a alguno de los objetivos
*/
int busca_dir(struct in_addr dir)
{
  struct host *ht = lista_hosts;
  while (ht) {
    if (ht->dir.s_addr == dir.s_addr) return 1;
    ht = ht->next;
  }
  return 0;
}

/*
  Aade un puerto abierto a un objetivo
*/
int add_port(struct in_addr dir, unsigned short p)
{
  struct host *ht = lista_hosts;
  int c;

  while (ht) {
    if (ht->dir.s_addr == dir.s_addr) break;
    ht = ht->next;
  }
  if (!ht) return 0;
  
  for (c = 0; c < ht->npuertos; c++)
    if (ht->puertos[c].n == p) return 0;
    
  ht->puertos[ht->npuertos++].n = p;
  ht->puertos[ht->npuertos-1].st = 0;
  return 1;
}

/*
  Aade un puerto filtrado a un objetivo
*/
int add_unreach_port(struct in_addr dir, unsigned short p)
{
  struct host *ht = lista_hosts;
  int c;

  while (ht) {
    if (ht->dir.s_addr == dir.s_addr) break;
    ht = ht->next;
  }
  if (!ht) return 0;
  
  for (c = 0; c < ht->npuertos; c++)
    if (ht->puertos[c].n == p) return 0;
    
  ht->puertos[ht->npuertos++].n = p;
  ht->puertos[ht->npuertos-1].st = 1;
  return 1;
}

int is_port_of(int p)
{
  if (host_scanned->respuestas[p]) return 1;
  return 0;
}

void set_timeout()
{
  gettimeofday(&timenow, NULL);
  timeout_sec = timenow.tv_sec;
  timeout_usec = timenow.tv_usec;
}

int get_timeout()
{
  gettimeofday(&timenow, NULL);

  if (host_scanned) {
    if (timenow.tv_sec > (timeout_sec + host_scanned->timeout.tv_sec)) {
      if (timenow.tv_usec > (timeout_usec + host_scanned->timeout.tv_usec)) return 1;
      if (timenow.tv_sec > (timeout_sec + host_scanned->timeout.tv_sec + 1)) return 1;
    }
    return 0;
  }
  
  if (timenow.tv_sec > (timeout_sec + scan_timeout_sec)) {
    if (timenow.tv_usec > (timeout_usec + scan_timeout_msec)) return 1;
    if (timenow.tv_sec > (timeout_sec + scan_timeout_sec + 1)) return 1;
  }
  return 0;
}

void scan_ports()
{
  int total, fdr, c, d, f;
  struct in_addr mdir; 
  struct host *ht = lista_hosts;
  int pasadas, syns_env = 0, ant, salir;
  
  mdir = mi_ip();

  src = rand() % 0xffff;

  fdr = misocket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  if (fdr < 0) {
    printf(" Error creando socket: %s\n", strerror(errno));
    fin(0);
  }
  if (setsockopt(fdr, SOL_SOCKET, SO_BROADCAST, &e, 4)) {
    printf(" Error: setsockopt(): %s\n", strerror(errno));
    exit(0);
  }
  total = npuertos * nhosts;

  printf("Escaneando puertos\n");
  fflush(stdout);

  for (c = 0; c < nhosts; c++) { 

    if (verbose) printf("\nEscaneando %s (%s)\n", ht->name, inet_ntoa(ht->dir));
    fflush(stdout);

    ht->respuestas = (int*) malloc(0xffff * sizeof(int));
    memset(ht->respuestas, 0, 0xffff * sizeof(int));
    
    host_scanned = ht;

    pasadas = ant = salir = 0;

    if (verbose > 1) printf("Syns enviados: ");
    fflush(stdout);

    for (;;) {

      e = 0;
      f = 0;
      syns_env = 0;
      tcnt = tacks = tfil = 0;
      f = 0;

      for (d = 0; d < npuertos; d++) {
	
	if (is_port_of(rand_puertos[d])) continue;

	TCP(fdr, mdir, ht->dir, src, rand_puertos[d], TH_SYN);
	
	syns_env++;
	f++;
	
	if (f == MAX_PACKETS) {

	  set_timeout();
	  
	  while ((tcnt + tacks + tfil) < f) {
	    procesa_packet();
	    if (get_timeout()) break;
	  }
	  f = 0;
	  tcnt = 0;
	  tacks = 0;
	  tfil = 0;
	}
      }

      set_timeout();
	
      while ((tcnt + tacks + tfil) < f) {
	procesa_packet();
	if (get_timeout()) break;
      }
      
      if (verbose > 1) printf("%i, ", syns_env);
      fflush(stdout);

      if (!syns_env) break;

      if (syns_env == ant) salir++;
      else salir = 0;
      ant = syns_env;
      if (salir == 2) break;

    }
    
    if (verbose > 1) printf("\n");

    print_results(ht);

    free(ht->respuestas);

    ht = ht->next;
  }

}
  
void new_puerto(int n)
{
  ports_to_scan[n] = 1;
  puertos[npuertos++].n = n;
}

void read_etc_services()
{
  struct servent *se; 
  int n = 0;

  while ((se = getservent())) if (!strcasecmp("tcp",se->s_proto)) n++;
  
  puertos = (struct puerto*) malloc(n * sizeof(struct puerto));
  setservent(0);
  while ((se = getservent())) 
    if (!strcasecmp("tcp",se->s_proto)) new_puerto(htons(se->s_port));
}

void enlaza(int fd, char *interfaz)
{
  struct sockaddr sa;

  strncpy(sa.sa_data, interfaz, sizeof(sa.sa_data));
  if (bind(fd, &sa, sizeof(sa))) {
    perror("bind()");
    exit(0);
  }

  if (!iniciado) printf("Usando interfaz %s\n", interfaz);
  iniciado = 1;

  if (!strncmp(interfaz, "lo", 2)) {
    head_offset = 14;
    return;
  }

  if (!strncmp(interfaz, "eth", 3)) {
    head_offset = 14;
    return;
  }

  if (!strncmp(interfaz, "ppp", 3)) {
    head_offset = 0;
    return;
  }

  if (!strncmp(interfaz, "ippp", 4)) {
    head_offset = 0;
    return;
  }

  printf("Error: Interfaz desconocida (%s). Reportalo a jdoing@bigfoot.com\n", interfaz);
  exit(0);
}

int cn = 0;

int procesa_packet()
{
  char buf[4096];
  struct ip *iph2, *iph;
  struct icmp *icmph;
  struct tcphdr *tcph, *tcph2;
  char *ptr;

 lee:
  memset(buf, 0, 4096);
  if (!read_ip_packet(buf, 48)) return 0;

  iph = (struct ip*) buf;

  if (iph->ip_p == 6) { /* protocolo tcp */
    
    if (iph->ip_src.s_addr != host_scanned->dir.s_addr) goto lee;    

    tcph = (struct tcphdr*) (buf + (iph->ip_hl * 4));
    
    if ((tcph->th_flags & TH_RST) == TH_RST)
      if (tcph->th_dport == htons(src)) {
	host_scanned->respuestas[htons(tcph->th_sport)] = 1;
	acks++;
	tacks++;
	if (debug > 1) {
	  printf("TCP ack desde %s [%i]\n", inet_ntoa(iph->ip_src), htons(tcph->th_sport));
	  fflush(stdout);
	}
	return 1;
      }
    
    if (tcph->th_flags == (TH_ACK | TH_SYN))
      if (tcph->th_dport == htons(src))
	if (add_port(iph->ip_src, htons(tcph->th_sport))) {
	  host_scanned->respuestas[htons(tcph->th_sport)] = 1;
	  e++;
	  tcnt++;
	  if (debug) {
	    printf("TCP syn/ack desde %s [%i]\n", inet_ntoa(iph->ip_src), htons(tcph->th_sport));
	    fflush(stdout);
	  }
	  return 1;
	}

    goto lee;
  }

  if (iph->ip_p == 1) { /* protocolo icmp */

    icmph = (struct icmp*) (buf + (iph->ip_hl * 4));

    if (icmph->icmp_type != 3) goto lee;

    ptr = (char*) icmph;
    ptr += 8;
    iph2 = (struct ip*) ptr;
    tcph2 = (struct tcphdr*) ((char*)iph2 + (iph2->ip_hl * 4));

    if (iph2->ip_dst.s_addr != host_scanned->dir.s_addr) goto lee;    

    if (add_unreach_port(iph2->ip_dst, htons(tcph2->th_dport))) {
      host_scanned->respuestas[htons(tcph2->th_dport)] = 1;
      filtrados++;
      tfil++;
    }

    goto lee;

  }

  goto lee;
}
    



