
#include "netscan.h"

static int narg = 0, nargs;

static int is_optw(char*, char* );
static int req(char, char *);

char *next_target(int c, char **v, char *opt)
{
  nargs = c;
 
  while (++narg < nargs) {
    
    if (is_optw(v[narg], opt) == 1) {
      narg++;
      continue;
    }
    if (is_optw(v[narg], opt) == 2) continue;
    
    return v[narg];
  }
  return NULL;
}

static int is_optw(char *opt, char *opts )
{
  int c;
  if (opt[0] != '-') return 0;

  for (c = 1; c < strlen(opt); c++) {
    if (req(opt[c], opts)) {
      if (c == (strlen(opt) - 1)) return 1;
      else return 2;
    }
  }
  return 2;
}

static int req(char opt, char *opts)
{
  int c;
  for (c = 0; c < strlen(opts); c++) {
    if (opt != opts[c]) continue;
    if (opts[c + 1] == ':') return 1;
    return 0;
  }
  return 0;
}

void init_rng(void )
{
  struct timeval tv;
  struct timezone tz;

  gettimeofday(&tv, &tz);
  srand((tv.tv_usec * 100) + tv.tv_sec);  
}

int misocket(int fam, int tipo, int proto)
{
  int ret;
  int uno = 1;

  ret = socket(fam, tipo, proto);

  if (ret < 1) {
    printf("Error creando socket.\nsocket(): %s\n", strerror(errno));
    exit(0);
  }

  if (setsockopt(ret, SOL_SOCKET, SO_BROADCAST, &uno, sizeof(uno)) < 0) 
    perror("setsockopt():");
   
  return ret;
}

