
#include "netsniff.h"

pcap_t *pd;
bpf_u_int32 lnet, nmask;
struct bpf_program filtro;
int head_offset;

extern void mira_timeout();
extern int nopromisc;
extern int swaps(int);
extern void procesa(struct ip*);

void bucle();

void set_pcap_filter(char *device)
{
  char error[256];

  if (!nopromisc) { 
  	if (!(pd = pcap_open_live(device, 256, 1, 1000, error))) {
    	printf(" pcap_open_live(): %s\n",error);
    	exit(0);
  	}
  } else {
	if (!(pd = pcap_open_live(device, 256, 0, 1000, error))) {
    	printf(" pcap_open_live(): %s\n",error);
    	exit(0);
  	}
  }

  if (pcap_lookupnet(device, &lnet, &nmask, error) < 0) {
    printf(" pcap_lookupnet(): %s\n",error);
    exit(0);
  }

  nmask = 0xfffff000;

  if (pcap_compile(pd, &filtro, "\x00", 1, nmask) < 0) {
    printf(" pcap_compile(): %s\n",pcap_geterr(pd));
    exit(0);
  }

  if (pcap_setfilter(pd, &filtro) < 0) {
    printf(" pcap_setfilter(): %s\n",pcap_geterr(pd));
    exit(0);
  }


  switch(pcap_datalink(pd)) {
  case DLT_EN10MB: 
    head_offset = 14; 
    break;
  case DLT_IEEE802: 
    head_offset = 22; 
    break;
  case DLT_NULL: 
    head_offset = 4; 
    break;
  case DLT_SLIP:
    head_offset = 16;
    break;
  case DLT_PPP: 
    head_offset = 4;
    break;
  case DLT_RAW: 
    head_offset = 0; 
    break;
  default: 
    printf(" pcap_datalink(): tipo de enlace desconocido\n");
    exit(0);
    break;
  }
}

char *read_ippacket()
{
  struct pcap_pkthdr head;
  char *ret = NULL;
  
  ret = (char*) pcap_next(pd, &head);
  if (ret) ret += head_offset;
  else return NULL;

  if ((ret[0] & 0x40) != 0x40) return NULL;

  return ret;
}


void bucle()
{
  struct ip *iph;
  u_int32_t t1, t2;

  t2 = t1 = time(NULL);

  for (;;) {
    iph = (struct ip*) read_ippacket();

    if (iph) 
      if ((swaps(iph->ip_off) & 0x1FFF) == 0)
		if (iph->ip_p == 6) procesa(iph);
    
    if ((t2 = time(NULL)) != t1) {
      mira_timeout();
      t1 = t2;
    }
  }
}
